diff -pruN 0.87-5/debian/changelog 0.87-6/debian/changelog
--- 0.87-5/debian/changelog	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/changelog	2021-02-02 00:29:33.000000000 +0000
@@ -1,3 +1,29 @@
+curvedns (0.87-6) unstable; urgency=medium
+
+  * Team Upload
+
+  [ Jan Mojžíš ]
+  * Added chroot patch
+  * Added nonce-separation patch
+  * Updated tcp-buffersize patch, updated global_ip_tcp_buffersize to 65537
+    bytes. And also resized internal response buffers to 65536 bytes to allow
+    large DNS and DNSCurve answers over TCP.
+  * d/compat - bump debhelper compat level to 12 and use debhelper-compat
+  * d/control - bump to standards version 4.3.0 (no modifications)
+  * d/control - added Pre-Depends: ${misc:Pre-Depends}
+
+  [ Debian Janitor ]
+  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
+    Repository-Browse.
+  * Update standards version to 4.4.1, no changes needed.
+
+  [ Samuel Henrique ]
+  * Bump DH to 13
+  * Bump Standards-Version to 4.5.1
+  * d/control: Add 'Rules-Requires-Root: no'
+
+ -- Samuel Henrique <samueloph@debian.org>  Tue, 02 Feb 2021 00:29:33 +0000
+
 curvedns (0.87-5) unstable; urgency=medium
 
   [ Raphaël Hertzog ]
diff -pruN 0.87-5/debian/compat 0.87-6/debian/compat
--- 0.87-5/debian/compat	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/compat	1970-01-01 00:00:00.000000000 +0000
@@ -1 +0,0 @@
-11
diff -pruN 0.87-5/debian/control 0.87-6/debian/control
--- 0.87-5/debian/control	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/control	2021-02-02 00:29:33.000000000 +0000
@@ -4,16 +4,18 @@ Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: NEVEU Stephane <stefneveu@gmail.com>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 13),
  libev-dev,
  libsodium-dev,
  ronn,
 Homepage: http://curvedns.on2it.net/
-Standards-Version: 4.1.5
+Standards-Version: 4.5.1
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/pkg-security-team/curvedns.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/curvedns
 
 Package: curvedns
+Pre-Depends: ${misc:Pre-Depends}
 Depends: adduser,
  ${misc:Depends},
  ${shlibs:Depends},
@@ -24,4 +26,3 @@ Description: DNS/DNSCurve forwarding nam
  .
  CurveDNS is the first publicly released forwarding implementation
  that implements the DNSCurve protocol
-
diff -pruN 0.87-5/debian/curvedns.default 0.87-6/debian/curvedns.default
--- 0.87-5/debian/curvedns.default	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/curvedns.default	2021-02-02 00:29:33.000000000 +0000
@@ -16,6 +16,24 @@ REMOTEIP=127.0.0.2
 # this is passed to curvedns(8) as fourth parameter
 REMOTEPORT=53
 
+# Directory to chroot into after startup
+ROOT=/var/lib/curvedns/empty
+
+# Nonce separation
+# When several servers share a key, than servers must use separate nonces, for example:
+# the first of four servers is configured to use CURVEDNS_NONCE_SEPARATION_BITS='100',
+# the second is configured to use CURVEDNS_NONCE_SEPARATION_BITS='101',
+# the third is configured to use CURVEDNS_NONCE_SEPARATION_BITS='110', and
+# the fourth is configured to use CURVEDNS_NONCE_SEPARATION_BITS='111'.
+#
+# CURVEDNS_NONCE_SEPARATION_BITS='' means no separation bits.
+# CURVEDNS_NONCE_SEPARATION_BITS is limited by 16bits (65536 variants),
+# e.g. CURVEDNS_NONCE_SEPARATION_BITS='1111111111111111'
+#
+# By default we set '0'. So we have space to switch to
+# CURVEDNS_NONCE_SEPARATION_BITS starting with 1 in the future.
+CURVEDNS_NONCE_SEPARATION_BITS='0'
+
 #Optionnal CurveDNS configuration, see curvedns(8)
 #CURVEDNS_INTERNAL_TIMEOUT=1.2
 #CURVEDNS_UDP_TRIES=2
diff -pruN 0.87-5/debian/curvedns.dirs 0.87-6/debian/curvedns.dirs
--- 0.87-5/debian/curvedns.dirs	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/curvedns.dirs	2021-02-02 00:29:33.000000000 +0000
@@ -1,2 +1,2 @@
 /etc/curvedns
-/var/lib/curvedns
+/var/lib/curvedns/empty
diff -pruN 0.87-5/debian/curvedns.service 0.87-6/debian/curvedns.service
--- 0.87-5/debian/curvedns.service	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/curvedns.service	2021-02-02 00:29:33.000000000 +0000
@@ -9,7 +9,7 @@ EnvironmentFile=/var/lib/curvedns/numeri
 EnvironmentFile=/etc/default/curvedns
 EnvironmentFile=/etc/curvedns/curvedns_private_key.hex
 ExecStart=/usr/sbin/curvedns ${IP} ${PORT} ${REMOTEIP} ${REMOTEPORT}
-Restart=on-failure
+Restart=always
 SystemCallFilter=~ptrace
 PrivateDevices=yes
 
diff -pruN 0.87-5/debian/.gitlab-ci.yml 0.87-6/debian/.gitlab-ci.yml
--- 0.87-5/debian/.gitlab-ci.yml	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/.gitlab-ci.yml	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,16 @@
+include: https://salsa.debian.org/salsa-ci-team/pipeline/raw/master/salsa-ci.yml
+
+build:
+    extends: .build-unstable
+
+reprotest:
+    extends: .test-reprotest
+
+lintian:
+    extends: .test-lintian
+
+autopkgtest:
+    extends: .test-autopkgtest
+
+piuparts:
+    extends: .test-piuparts
diff -pruN 0.87-5/debian/patches/chroot.patch 0.87-6/debian/patches/chroot.patch
--- 0.87-5/debian/patches/chroot.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/patches/chroot.patch	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,50 @@
+From: =?utf-8?q?Jan_Moj=C5=BE=C3=AD=C5=A1?= <jan.mojzis@gmail.com>
+Date: Sun, 11 Nov 2018 10:22:26 +0100
+Subject: chroot
+
+---
+ curvedns.c | 17 +++++++++++++++++
+ 1 file changed, 17 insertions(+)
+
+diff --git a/curvedns.c b/curvedns.c
+index 0287c58..f4b00a2 100644
+--- a/curvedns.c
++++ b/curvedns.c
+@@ -57,6 +57,7 @@ static int usage(const char *argv0) {
+ 	debug_log(DEBUG_FATAL, " CURVEDNS_PRIVATE_KEY\n\tThe hexadecimal representation of the server's private (secret) key\n");
+ 	debug_log(DEBUG_FATAL, " UID\n\tNon-root user id to run under\n");
+ 	debug_log(DEBUG_FATAL, " GID\n\tNon-root user group id to run under\n");
++	debug_log(DEBUG_FATAL, " ROOT\n\tDirectory to chroot into after startup\n");
+ 	debug_log(DEBUG_FATAL, " [CURVEDNS_SOURCE_IP]\n\tThe IP to bind on when target server is contacted (default: [none])\n");
+ 	debug_log(DEBUG_FATAL, " [CURVEDNS_INTERNAL_TIMEOUT]\n\tNumber of seconds to declare target server timeout (default: 1.2)\n");
+ 	debug_log(DEBUG_FATAL, " [CURVEDNS_UDP_TRIES]\n\tWhen timeout to target server, how many tries in total (default: 2)\n");
+@@ -138,6 +139,7 @@ static int getenvoptions() {
+ 
+ int main(int argc, char *argv[]) {
+ 	int uid, gid, tmp;
++	char *chroot_dir;
+ 
+ 	if (argc != 5)
+ 		return usage(argv[0]);
+@@ -191,6 +193,21 @@ int main(int argc, char *argv[]) {
+ 		return 1;
+ 	}
+ 
++	// chdir into ROOT directory and call chroot()
++	chroot_dir = getenv("ROOT");
++	if(chroot_dir != NULL) {
++		debug_log(DEBUG_INFO,"main(): chroot()'ing into ROOT\n");
++		if(chdir(chroot_dir) != 0) {
++			debug_log(DEBUG_FATAL, "main(): unable to chdir() into ROOT-directory\n");
++			return 1;
++		}
++
++		if(chroot(".") != 0) {
++			debug_log(DEBUG_FATAL, "main(): chroot() failed\n");
++			return 1;
++		}
++	}
++
+ 	// Do exactly this ;]
+ 	debug_log(DEBUG_INFO, "main(): throwing away root privileges\n");
+ 	if (setgid(gid) != 0) {
diff -pruN 0.87-5/debian/patches/nonce-separation.patch 0.87-6/debian/patches/nonce-separation.patch
--- 0.87-5/debian/patches/nonce-separation.patch	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/patches/nonce-separation.patch	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,215 @@
+From: =?utf-8?q?Jan_Moj=C5=BE=C3=AD=C5=A1?= <jan.mojzis@gmail.com>
+Date: Mon, 19 Nov 2018 19:45:16 +0100
+Subject: nonce separation
+Description: Added support for nonce separation
+ This patch adds support for nonce separation. When several servers share a key,
+ than servers must use separate nonces, for example:
+ the first of four servers is configured to use CURVEDNS_NONCE_SEPARATION_BITS='100',
+ the second is configured to use CURVEDNS_NONCE_SEPARATION_BITS='101',
+ the third is configured to use CURVEDNS_NONCE_SEPARATION_BITS='110', and
+ the fourth is configured to use CURVEDNS_NONCE_SEPARATION_BITS='111'.
+ The patch also creates the nonce in slightly different way,
+ first 8bytes is the number of nanoseconds since epoch packed into
+ machine-independent format.
+ For more information see: https://dnscurve.org/out-implement.html
+ and https://dnscurve.org/in-implement.html.
+Author: Jan Mojzis
+Last-Update: 2018-11-19
+
+---
+ curvedns.c | 10 +++++++
+ dnscurve.c |  4 +--
+ misc.c     | 88 +++++++++++++++++++++++++++++++++++++++++++++++++++++---------
+ misc.h     |  4 ++-
+ 4 files changed, 91 insertions(+), 15 deletions(-)
+
+diff --git a/curvedns.c b/curvedns.c
+index f4b00a2..466b372 100644
+--- a/curvedns.c
++++ b/curvedns.c
+@@ -65,10 +65,12 @@ static int usage(const char *argv0) {
+ 	debug_log(DEBUG_FATAL, " [CURVEDNS_TCP_TIMEOUT]\n\tNumber of seconds before TCP session to client times out (default: 60.0)\n");
+ 	debug_log(DEBUG_FATAL, " [CURVEDNS_SHARED_SECRETS]\n\tNumber of shared secrets that can be cached (default: 5000)\n");
+ 	debug_log(DEBUG_FATAL, " [CURVEDNS_DEBUG]\n\tDebug level, 1: fatal, 2: error, 3: warning, 4: info, 5: debug (default: 2)\n");
++	debug_log(DEBUG_FATAL, " [CURVEDNS_NONCE_SEPARATION_BITS]\n\tNonce separation bits (default: [none]):\n\t the  first of four servers '100'\n\t the second of four servers '101'\n\t the  third of four servers '110'\n\t ...\n");
+ 	return 1;
+ }
+ 
+ static int getenvoptions() {
++	char *tmpstring = (char *)0;
+ 	int tmpi;
+ 	double tmpd;
+ 	char ip[INET6_ADDRSTRLEN];
+@@ -134,6 +136,14 @@ static int getenvoptions() {
+ 		debug_log(DEBUG_INFO, "shared secret cache: %d positions\n", global_shared_secrets);
+ 	}
+ 
++	if (misc_getenv_string("CURVEDNS_NONCE_SEPARATION_BITS", 0, &tmpstring)) {
++		debug_log(DEBUG_FATAL, "nonce start string is '%s'\n", tmpstring);
++	}
++	else {
++		debug_log(DEBUG_INFO, "nonce start string is (null)\n");
++	}
++	misc_crypto_nonce_init(tmpstring);
++
+ 	return 1;
+ }
+ 
+diff --git a/dnscurve.c b/dnscurve.c
+index cad596c..f151e60 100644
+--- a/dnscurve.c
++++ b/dnscurve.c
+@@ -368,7 +368,7 @@ int dnscurve_reply_streamlined_query(event_entry_t *general_entry) {
+ 	// Set everything for the encryption step:
+ 	memcpy(fullnonce, packet->nonce, 12);
+ 	time = ev_now(event_default_loop);
+-	misc_crypto_nonce(fullnonce + 12, &time, sizeof(time));
++	misc_crypto_nonce(fullnonce + 12);
+ 
+ 	result = dnscurve_get_shared_secret(packet);
+ 	if ((result < 0) || packet->ispublic) {
+@@ -441,7 +441,7 @@ int dnscurve_reply_txt_query(event_entry_t *general_entry) {
+ 	// Now write the streamline header:
+ 	memcpy(fullnonce, packet->nonce, 12);
+ 	time = ev_now(event_default_loop);
+-	misc_crypto_nonce(fullnonce + 12, &time, sizeof(time));
++	misc_crypto_nonce(fullnonce + 12);
+ 
+ 	result = dnscurve_get_shared_secret(packet);
+ 	if ((result < 0) || packet->ispublic) {
+diff --git a/misc.c b/misc.c
+index 200825b..f81b412 100644
+--- a/misc.c
++++ b/misc.c
+@@ -34,6 +34,9 @@
+  * $Revision$
+  */
+ 
++#include <time.h>
++#include <sys/time.h>
++
+ #include "misc.h"
+ #include "ip.h"
+ 
+@@ -101,6 +104,15 @@ int misc_getenv_key(const char *env, int mandatory, uint8_t *result) {
+ 	return 1;
+ }
+ 
++int misc_getenv_string(const char *env, int mandatory, char **result) {
++	char *ptr;
++	if (!(ptr = misc_getenv(env, mandatory))) {
++		return 0;
++	}
++	*result = ptr;
++	return 1;
++}
++
+ int misc_char_hex(char in, uint8_t *out) {
+ 	if ((in >= '0') && (in <= '9')) {
+ 		*out = in - '0';
+@@ -221,20 +233,72 @@ unsigned int misc_crypto_random(unsigned int n) {
+ 	return out[--outleft] % n;
+ }
+ 
+-// Make sure sizeof(nonce) >= 12
+-void misc_crypto_nonce(uint8_t *nonce, void *time, int len) {
+-	// We would like the first 64 bits to be time based.
+-	// The last 32 bits can be random.
++uint64_t misc_nanoseconds(void) {
+ 
+-	// XXX: but dirty solution, nicer way?
+-	if (len < 8) {
+-		memcpy(nonce, time, len);
+-	} else {
+-		memcpy(nonce, time, 8);
+-		len = 8;
++	struct timeval t;
++
++	gettimeofday(&t, (struct timezone *) 0);
++	return t.tv_sec * 1000000000LL + t.tv_usec * 1000LL;
++}
++
++static uint64_t noncecounter = 0;
++static uint8_t noncemask[2] = {0xff, 0xff};
++static uint8_t noncedata[2] = {0, 0};
++void misc_crypto_nonce_init(char *ns) {
++
++	int i;
++
++	noncecounter = misc_nanoseconds();
++
++	if (!ns) ns = "";
++	i = 0;
++	while (i < 16) {
++		if (!ns[i]) break;
++		if (ns[i] != '0' && ns[i] != '1') break;
++
++		noncemask[i/8] = noncemask[i/8] * 2;
++		noncedata[i/8] = noncedata[i/8] * 2 +  ns[i] - '0';
++		++i;
++	}
++	while (i < 16) {
++		noncemask[i/8] = noncemask[i/8] * 2 + 1;
++		noncedata[i/8] = noncedata[i/8] * 2;
++		++i;
++	}
++}
++
++void misc_crypto_nonce(uint8_t *nonce) {
++
++	uint64_t x;
++
++	// Do not decrease the counter if the clock jumps backwards !!
++	x = misc_nanoseconds();
++	if (noncecounter >= x) x = ++noncecounter;
++	noncecounter = x;
++
++	// Pack timestamp into machine-independent format
++	nonce[0] = x; x >>= 8;
++	nonce[1] = x; x >>= 8;
++	nonce[2] = x; x >>= 8;
++	nonce[3] = x; x >>= 8;
++	nonce[4] = x; x >>= 8;
++	nonce[5] = x; x >>= 8;
++	nonce[6] = x; x >>= 8;
++	nonce[7] = x;
++
++	for (x = 8; x < 12; ++x) {
++		nonce[x] = misc_crypto_random(256);
+ 	}
+-	for ( ; len < 12; len++)
+-		nonce[len] = misc_crypto_random(256);
++
++	// nonce-separation part
++	for (x = 0; x < 2; ++x) {
++		nonce[x + 8] &= noncemask[x];
++		nonce[x + 8] += noncedata[x];
++	}
++
++	debug_log(DEBUG_DEBUG, "misc_crypto_nonce(): %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x %02x\n",
++		nonce[0], nonce[1], nonce[2], nonce[3], nonce[4],nonce[5], nonce[6], nonce[7],
++		nonce[8], nonce[9], nonce[10], nonce[11]);
+ }
+ 
+ static const uint8_t kValues[] = {
+diff --git a/misc.h b/misc.h
+index d76c0b2..d636080 100644
+--- a/misc.h
++++ b/misc.h
+@@ -52,6 +52,7 @@ extern int misc_getenv_ip(const char *, int, anysin_t *);
+ extern int misc_getenv_int(const char *, int, int *);
+ extern int misc_getenv_double(const char *, int, double *);
+ extern int misc_getenv_key(const char *, int, uint8_t *);
++extern int misc_getenv_string(const char *, int, char **);
+ 
+ extern int misc_char_hex(char, uint8_t *);
+ extern int misc_hex_char(uint8_t, char *);
+@@ -65,6 +66,7 @@ extern void misc_randombytes(uint8_t *, unsigned long long);
+ 
+ extern int misc_crypto_random_init();
+ extern unsigned int misc_crypto_random(unsigned int);
+-extern void misc_crypto_nonce(uint8_t *, void *, int);
++extern void misc_crypto_nonce(uint8_t *);
++extern void misc_crypto_nonce_init(char *);
+ 
+ #endif /* MISC_H_ */
diff -pruN 0.87-5/debian/patches/series 0.87-6/debian/patches/series
--- 0.87-5/debian/patches/series	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/patches/series	2021-02-02 00:29:33.000000000 +0000
@@ -1,3 +1,5 @@
 tcp-buffersize.patch
 spelling.patch
 libsodium.patch
+chroot.patch
+nonce-separation.patch
diff -pruN 0.87-5/debian/patches/tcp-buffersize.patch 0.87-6/debian/patches/tcp-buffersize.patch
--- 0.87-5/debian/patches/tcp-buffersize.patch	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/patches/tcp-buffersize.patch	2021-02-02 00:29:33.000000000 +0000
@@ -1,18 +1,50 @@
 Description: Update global_ip_tcp_buffersize
- This patch updates global_ip_tcp_buffersize to 16384.
- Some replies grow up to 8192 octets.
+ Patch fixes the problem with large TCP responses (up to 65535 bytes).
+ Including DNSCurve protected responses sent over TCP.
+ Without the fix the regular response is limited by 8192 bytes
+ (global_ip_tcp_buffersize) and DNSCurve response is
+ limited by 4096 bytes (sizeof(sandbox)).
 Bug: https://github.com/curvedns/curvedns/issues/4
 Bug-Debian: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=870226
-Author: James Cloos
-Last-Update: 2017-07-31
+Last-Update: 2018-11-22
+
+---
+ dnscurve.c | 4 ++--
+ ip.c       | 2 +-
+ 2 files changed, 3 insertions(+), 3 deletions(-)
+
+diff --git a/dnscurve.c b/dnscurve.c
+index f151e60..1147e47 100644
+--- a/dnscurve.c
++++ b/dnscurve.c
+@@ -340,7 +340,7 @@ wrong:
+ int dnscurve_reply_streamlined_query(event_entry_t *general_entry) {
+ 	struct event_general_entry *entry = &general_entry->general;
+ 	struct dns_packet_t *packet = &entry->dns;
+-	uint8_t fullnonce[24], sandbox[4096];
++	uint8_t fullnonce[24], sandbox[65536];
+ 	ev_tstamp time;
+ 	int result;
+ 	size_t sandboxlen = sizeof(sandbox);
+@@ -412,7 +412,7 @@ wrong:
+ int dnscurve_reply_txt_query(event_entry_t *general_entry) {
+ 	struct event_general_entry *entry = &general_entry->general;
+ 	struct dns_packet_t *packet = &entry->dns;
+-	uint8_t fullnonce[24], sandbox[4096];
++	uint8_t fullnonce[24], sandbox[65536];
+ 	uint16_t tmpshort;
+ 	ev_tstamp time;
+ 	size_t sandboxlen = sizeof(sandbox), pos, rrdatalen;
+diff --git a/ip.c b/ip.c
+index 664377b..654d3b2 100644
 --- a/ip.c
 +++ b/ip.c
-@@ -45,7 +45,7 @@
+@@ -45,7 +45,7 @@ int global_ip_sockets_count = 0;
  ev_tstamp	global_ip_internal_timeout = 1.2;
  ev_tstamp	global_ip_tcp_external_timeout = 60.0;
  int			global_ip_tcp_max_number_connections = 25;
 -size_t		global_ip_tcp_buffersize = 8192;
-+size_t		global_ip_tcp_buffersize = 16384;
++size_t		global_ip_tcp_buffersize = 65537;
  size_t		global_ip_udp_buffersize = 4096;
  uint8_t		global_ip_udp_retries = 2;
  anysin_t	global_target_address;
diff -pruN 0.87-5/debian/rules 0.87-6/debian/rules
--- 0.87-5/debian/rules	2018-07-08 19:44:46.000000000 +0000
+++ 0.87-6/debian/rules	2021-02-02 00:29:33.000000000 +0000
@@ -11,4 +11,3 @@ override_dh_installman:
 	ronn -r $(CURDIR)/debian/curvedns.8.ronn
 	ronn -r $(CURDIR)/debian/curvedns-keygen.1.ronn
 	dh_installman
-
diff -pruN 0.87-5/debian/salsa-ci.yml 0.87-6/debian/salsa-ci.yml
--- 0.87-5/debian/salsa-ci.yml	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/salsa-ci.yml	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,4 @@
+---
+include:
+  - https://salsa.debian.org/salsa-ci-team/pipeline/raw/master/salsa-ci.yml
+  - https://salsa.debian.org/salsa-ci-team/pipeline/raw/master/pipeline-jobs.yml
diff -pruN 0.87-5/debian/tests/control 0.87-6/debian/tests/control
--- 0.87-5/debian/tests/control	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/tests/control	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,7 @@
+Tests: curvedns
+Depends: curvedns, python3, dq
+Restrictions: allow-stderr, isolation-container, needs-root
+
+Tests: nonce-separation
+Depends: curvedns, python3, dq
+Restrictions: allow-stderr
diff -pruN 0.87-5/debian/tests/curvedns 0.87-6/debian/tests/curvedns
--- 0.87-5/debian/tests/curvedns	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/tests/curvedns	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,89 @@
+#!/bin/sh
+# 20181111
+# Jan Mojzis
+# Public domain.
+
+set -e
+
+dn=`dirname "$0"`
+dir=`readlink -e "${dn}"`
+
+#change directory to $AUTOPKGTEST_TMP
+cd "${AUTOPKGTEST_TMP}"
+
+#XXX parse public-key
+dnscurvepk=`grep '(hexadecimal)' /etc/curvedns/README | cut -d ' ' -f1`
+echo "dnscurve publickey: ${dnscurvepk}" >&2
+
+#run fakednsserver.py
+${dir}/fakednsserver.py 127.0.0.2 53 &
+pid=$!
+
+sleep 1
+
+cleanup() {
+  ex=$?
+  rm -f *.log
+  #kill fakednsserver.py
+  kill -TERM "${pid}" 1>/dev/null 2>/dev/null || :
+  kill -KILL "${pid}" 1>/dev/null 2>/dev/null || :
+  exit "${ex}"
+}
+trap "cleanup" EXIT TERM INT
+
+query='www.testszone.SOMEWHERE'
+
+# query fakednsserver.py
+(
+  exec 2>&1
+  echo "A query over UDP (short response):"
+  dq -vv -a a "${query}" 127.0.0.2 || :
+  echo "TXT query over TCP (large ~64kB response):"
+  ( dq -vv -t -a txt "${query}" 127.0.0.2 || : ) | sort -u
+) > orig.log
+
+# try regular DNS query
+(
+  exec 2>&1
+  echo "A query over UDP (short response):"
+  dq -vv -a a "${query}" 127.0.0.1 || :
+  echo "TXT query over TCP (large ~64kB response):"
+  ( dq -vv -t -a txt "${query}" 127.0.0.1 || : ) | sort -u
+) > regular.log
+
+# try TXT DNSCurve query
+(
+  exec 2>&1
+  echo "A query over UDP (short response):"
+  dq -vv -a -S '' -k "${dnscurvepk}" a "${query}" 127.0.0.1 || :
+  echo "TXT query over TCP (large ~64kB response):"
+  ( dq -vv -t -a -S '' -k "${dnscurvepk}" txt "${query}" 127.0.0.1 || : ) | sort -u
+) > txt.log
+
+# try Streamlined DNSCurve query
+(
+  exec 2>&1
+  echo "A query over UDP (short response):"
+  dq -vv -a -s -k "${dnscurvepk}" a "${query}" 127.0.0.1 || :
+  echo "TXT query over TCP (large ~64kB response):"
+  ( dq -vv -t -a -s -k "${dnscurvepk}" txt "${query}" 127.0.0.1 || : ) | sort -u
+) > streamlined.log
+
+(
+  for file in orig.log regular.log txt.log streamlined.log; do
+    echo "${file}:"
+    cat "${file}"
+    echo
+  done
+) >&2
+
+for file in regular.log txt.log streamlined.log; do
+  if [ x"`grep '^answer:' orig.log | sha256sum`" != x"`grep '^answer:' ${file} | sha256sum`" ]; then
+    echo "curvedns test failed" >&2
+    exit 1
+  fi
+done
+
+
+echo "curvedns test works" >&2
+exit 0
diff -pruN 0.87-5/debian/tests/fakednsserver.py 0.87-6/debian/tests/fakednsserver.py
--- 0.87-5/debian/tests/fakednsserver.py	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/tests/fakednsserver.py	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,157 @@
+#!/usr/bin/env python3
+# 20181111
+# Jan Mojzis
+# Public domain.
+
+# Simple DNS responder
+# For TXT query sends large response (~64kB)
+# For other queries sends small A response
+
+import logging
+import socket
+import sys
+import select
+import struct
+
+T_TXT = b'\x00\x10'
+T_A = b'\x00\x01'
+C_IN = b'\x00\x01'
+
+def be16(x = 0):
+        """
+        pack uint16_t to big-endian
+        """
+
+        return struct.pack('>H', x)
+
+def be32(x = 0):
+        """
+        pack uint32_t to big-endian
+        """
+
+        return struct.pack('>I', x)
+
+def recvtcp(c):
+        """
+        """
+        ret = b''
+
+        data = c.recv(2)
+        l = struct.unpack('>H', data)[0]
+
+        while len(ret) != l:
+                data = c.recv(65536)
+                ret += data
+        return ret
+
+def sendtcp(c, response):
+        """
+        """
+
+        l = len(response)
+        c.sendall(be16(l) + response)
+
+
+if __name__ == '__main__':
+        logging.basicConfig(level=logging.DEBUG)
+
+        try:
+                ip = sys.argv[1]
+        except:
+                ip = '127.0.0.2'
+
+        try:
+                port = int(sys.argv[2])
+        except:
+                port = 53
+
+        logging.info("Starting fakednserver: %s:%d", ip, port)
+
+        udp = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
+        udp.bind((ip, port))
+
+        tcp = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
+        tcp.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
+        tcp.bind((ip, port))
+        tcp.listen(10)
+
+        while True:
+                r, w, e = select.select([udp, tcp], [], [], None)
+                for s in r:
+                        t = None
+                        if s == tcp:
+                                c, addr = tcp.accept()
+                                data = recvtcp(c)
+                                t = 'tcp'
+                        elif s == udp:
+                                data, addr = udp.recvfrom(4096)
+                                t = 'udp'
+                        else:
+                                continue
+
+                        domain = b''
+                        opcode = (data[2] >> 3) & 15
+                        if opcode != 0:
+                                continue
+
+                        start = 12
+                        length = data[start]
+                        while length != 0:
+                                domain += data[start + 1:start + length + 1] + b'.'
+                                start += length + 1
+                                length = data[start]
+                        qtype = data[start + 1: start + 3]
+
+                        #XXX drop tail
+                        data = data[0:start + 5]
+
+                        logging.info("DNS %s request from: %s: %s", t, addr, domain)
+
+                        if qtype == T_TXT:
+                                answers = 240
+                        else:
+                                answers = 1
+
+                        response = b''
+                        response += data[:2]            # ID
+                        response += b"\x81\x80"         # FLAGS
+                        response += data[4:6]           # QUESTION
+                        response += be16(answers)       # ANSWER
+                        response += be16(0)             # AUTHORITY
+                        response += be16(0)             # ADDITIONAL
+                        response += data[12:]           # NAME
+
+                        truncated = b''
+                        truncated += data[:2]
+                        truncated += b"\x83\x80"
+                        truncated += response[4:]
+
+                        if qtype == T_TXT:
+                                # long TXT response over TCP
+                                for i in range(answers):
+                                        response += b'\xc0\x0c'         # NAME (pointer to name)
+                                        response += T_TXT               # TYPE TXT
+                                        response += C_IN                # CLASS IN
+                                        response += be32(60)            # TTL
+                                        txtlen = 255
+                                        response += be16(txtlen)        # RDLENGTH
+                                        response += txtlen * b'\xfe'    # RDATA (note: first byte is the length)
+
+                        else:
+                                # short A response over UDP
+                                for i in range(answers):
+                                        response += b'\xc0\x0c'         # NAME (pointer to name)
+                                        response += T_A                 # TYPE A
+                                        response += C_IN                # CLASS IN
+                                        response += be32(60)            # TTL
+                                        response += be16(4)             # RDLENGTH
+                                        response += b'\x00\x00\x00\x00' # RDATA
+
+                        if s == tcp:
+                                sendtcp(c, response)
+                                c.close()
+                        if s == udp:
+                                if len(response) > 512:
+                                        udp.sendto(truncated, addr)
+                                else:
+                                        udp.sendto(response, addr)
diff -pruN 0.87-5/debian/tests/nonce-separation 0.87-6/debian/tests/nonce-separation
--- 0.87-5/debian/tests/nonce-separation	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/tests/nonce-separation	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,124 @@
+#!/bin/sh
+# 20181119
+# Jan Mojzis
+# Public domain.
+
+set -e
+
+dn=`dirname "$0"`
+dir=`readlink -e "${dn}"`
+
+#change directory to $AUTOPKGTEST_TMP
+cd "${AUTOPKGTEST_TMP}"
+
+PATH="/usr/sbin:/sbin:${PATH}"
+export PATH
+
+#generate public and secret keys
+keys=`curvedns-keygen`
+pk=`echo "${keys}" | grep '^Hex public key:.' | sed 's/^Hex public key:.//'`
+CURVEDNS_PRIVATE_KEY=`echo "${keys}" | grep '^Hex secret key:.' | sed 's/^Hex secret key:.//'`
+export CURVEDNS_PRIVATE_KEY
+
+FAKEDNSPORT=10053
+CURVEDNSPORT=11053
+query='www.testszone.SOMEWHERE'
+
+#run fakednsserver.py
+${dir}/fakednsserver.py 127.0.0.1 "${FAKEDNSPORT}" >fakednsserver.log 2>&1 &
+pid=$!
+
+rm -f nonces.txt *.log
+
+(
+  echo '0 [01234567]'
+  echo '1 [89abcdef]'
+
+  echo '00 [0123]'
+  echo '01 [4567]'
+  echo '10 [89ab]'
+  echo '11 [cdef]'
+
+  echo '000 [01]'
+  echo '001 [23]'
+  echo '010 [45]'
+  echo '011 [67]'
+  echo '100 [89]'
+  echo '101 [ab]'
+  echo '110 [cd]'
+  echo '111 [ef]'
+
+  echo '0000 0'
+  echo '1111 f'
+
+  echo '00000000 00'
+  echo '11111111 ff'
+
+  echo '000000000000 000'
+  echo '111111111111 fff'
+
+  echo '0000000000000000 0000'
+  echo '1111111111111111 ffff'
+
+  # uncomment line below and test must fail
+  # echo "000000000000 001"
+) | (
+
+  while read noncestart exp; do
+
+    env \
+    UID=`id -u` \
+    GID=`id -g` \
+    CURVEDNS_DEBUG=5 \
+    CURVEDNS_NONCE_SEPARATION_BITS="${noncestart}" \
+    CURVEDNS_PRIVATE_KEY="${CURVEDNS_PRIVATE_KEY}" \
+    curvedns 127.0.0.1 "${CURVEDNSPORT}" 127.0.0.1 "${FAKEDNSPORT}" 2>curvedns.log &
+    cpid=$!
+
+    cleanup() {
+      ex=$?
+      #kill fakednsserver.py
+      kill -TERM "${pid}" 1>/dev/null 2>/dev/null || :
+      kill -KILL "${pid}" 1>/dev/null 2>/dev/null || :
+      #kill curvedns
+      kill -TERM "${cpid}" 1>/dev/null 2>/dev/null || :
+      kill -KILL "${cpid}" 1>/dev/null 2>/dev/null || :
+      rm -f *.log
+      exit "${ex}"
+    }
+    trap "cleanup" EXIT TERM INT
+
+    sleep 1
+
+    for i in `seq 1 10`; do
+      dq -vv -s -a -k "${pk}" -p "${CURVEDNSPORT}" a "${query}" 127.0.0.1 >dq.log 2>&1 || :
+      rettm=`grep '^dq: debug: DNSCurve nonce: ' dq.log | grep -v '000000000000000000000000$' | head -1 | cut -d ' ' -f5 | cut -b 25-40`
+      ret=`grep '^dq: debug: DNSCurve nonce: ' dq.log | grep -v '000000000000000000000000$' | head -1 | cut -d ' ' -f5 | cut -b 41- | grep "^${exp}"`
+      if [ x"${ret}" = x ]; then
+        (
+          echo "nonce separation test failed for nonce_separation_bits ${noncestart} and regular_expression ${exp}:"
+          echo "curvedns.log:"
+          cat curvedns.log
+          echo
+          echo "dq.log:"
+          cat dq.log
+          echo
+        ) >&2
+        exit 1
+      else
+        echo "${rettm} ${ret}: ${noncestart} ${exp}" >>nonces.txt
+      fi
+    done || exit 1
+
+    kill -TERM "${cpid}" 1>/dev/null 2>/dev/null || :
+    kill -KILL "${cpid}" 1>/dev/null 2>/dev/null || :
+    sleep 1
+
+  done || exit 1
+) || exit 1
+
+echo "nonce separation test works !" >&2
+echo "nonce_timestamp_part nonce_random_or_nonce_separation_part: nonce_separation_bits: regular_expressions" >&2
+cat nonces.txt >&2
+rm -f nonces.txt
+exit 0
diff -pruN 0.87-5/debian/upstream/metadata 0.87-6/debian/upstream/metadata
--- 0.87-5/debian/upstream/metadata	1970-01-01 00:00:00.000000000 +0000
+++ 0.87-6/debian/upstream/metadata	2021-02-02 00:29:33.000000000 +0000
@@ -0,0 +1,5 @@
+---
+Bug-Database: https://github.com/curvedns/curvedns/issues
+Bug-Submit: https://github.com/curvedns/curvedns/issues/new
+Repository: https://github.com/curvedns/curvedns.git
+Repository-Browse: https://github.com/curvedns/curvedns
